@rem
@rem Copyright 2015 the original author or authors.
@rem
@rem Licensed under the Apache License, Version 2.0 (the "License");
@rem you may not use this file except in compliance with the License.
@rem You may obtain a copy of the License at
@rem
@rem      https://www.apache.org/licenses/LICENSE-2.0
@rem
@rem Unless required by applicable law or agreed to in writing, software
@rem distributed under the License is distributed on an "AS IS" BASIS,
@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@rem See the License for the specific language governing permissions and
@rem limitations under the License.
@rem

@if "%DEBUG%"=="" @echo off
@rem ##########################################################################
@rem
@rem  eaglercraft startup script for Windows
@rem
@rem ##########################################################################

@rem Set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" setlocal

set DIRNAME=%~dp0
if "%DIRNAME%"=="" set DIRNAME=.
@rem This is normally unused
set APP_BASE_NAME=%~n0
set APP_HOME=%DIRNAME%..

@rem Resolve any "." and ".." in APP_HOME to make it shorter.
for %%i in ("%APP_HOME%") do set APP_HOME=%%~fi

@rem Add default JVM options here. You can also use JAVA_OPTS and EAGLERCRAFT_OPTS to pass JVM options to this script.
set DEFAULT_JVM_OPTS="-Djava.library.path=lwjgl-rundir"

@rem Find java.exe
if defined JAVA_HOME goto findJavaFromJavaHome

set JAVA_EXE=java.exe
%JAVA_EXE% -version >NUL 2>&1
if %ERRORLEVEL% equ 0 goto execute

echo.
echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.

goto fail

:findJavaFromJavaHome
set JAVA_HOME=%JAVA_HOME:"=%
set JAVA_EXE=%JAVA_HOME%/bin/java.exe

if exist "%JAVA_EXE%" goto execute

echo.
echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME%
echo.
echo Please set the JAVA_HOME variable in your environment to match the
echo location of your Java installation.

goto fail

:execute
@rem Setup the command line

set CLASSPATH=%APP_HOME%\lib\eaglercraft.jar;%APP_HOME%\lib\commons-lang3-3.1.jar;%APP_HOME%\lib\bcprov-jdk15on-1.47.jar;%APP_HOME%\lib\codecjorbis-20101023.jar;%APP_HOME%\lib\librarylwjglopenal-20100824.jar;%APP_HOME%\lib\lwjgl_util-2.9.0.jar;%APP_HOME%\lib\libraryjavasound-20101123.jar;%APP_HOME%\lib\codecwav-20101023.jar;%APP_HOME%\lib\guava-14.0.jar;%APP_HOME%\lib\eaglercraft.jar;%APP_HOME%\lib\soundsystem-20120107.jar;%APP_HOME%\lib\lwjgl-platform-2.9.0-natives-linux.jar;%APP_HOME%\lib\gson-2.2.2.jar;%APP_HOME%\lib\java-websocket.jar;%APP_HOME%\lib\argo-2.25_fixed.jar;%APP_HOME%\lib\commons-io-2.4.jar;%APP_HOME%\lib\lwjgl-2.9.0.jar


@rem Execute eaglercraft
"%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %EAGLERCRAFT_OPTS%  -classpath "%CLASSPATH%" net.lax1dude.eaglercraft.MinecraftMain %*

:end
@rem End local scope for the variables with windows NT shell
if %ERRORLEVEL% equ 0 goto mainEnd

:fail
rem Set variable EAGLERCRAFT_EXIT_CONSOLE if you need the _script_ return code instead of
rem the _cmd.exe /c_ return code!
set EXIT_CODE=%ERRORLEVEL%
if %EXIT_CODE% equ 0 set EXIT_CODE=1
if not ""=="%EAGLERCRAFT_EXIT_CONSOLE%" exit %EXIT_CODE%
exit /b %EXIT_CODE%

:mainEnd
if "%OS%"=="Windows_NT" endlocal

:omega
